blob: d09ab4afbda4931a4aef8d34eb2f64bf3d8e9fd9 [file] [log] [blame]
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +02001#!/bin/sh
Greg Kroah-Hartmanb2441312017-11-01 15:07:57 +01002# SPDX-License-Identifier: GPL-2.0
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +02003#
4# link vmlinux
5#
Masahiro Yamadad151e972019-01-17 09:10:04 +09006# vmlinux is linked from the objects selected by $(KBUILD_VMLINUX_OBJS) and
7# $(KBUILD_VMLINUX_LIBS). Most are built-in.a files from top-level directories
8# in the kernel tree, others are specified in arch/$(ARCH)/Makefile.
9# $(KBUILD_VMLINUX_LIBS) are archives which are linked conditionally
10# (not within --whole-archive), and do not require symbol indexes added.
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020011#
12# vmlinux
13# ^
14# |
Masahiro Yamadad151e972019-01-17 09:10:04 +090015# +--< $(KBUILD_VMLINUX_OBJS)
16# | +--< init/built-in.a drivers/built-in.a mm/built-in.a + more
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020017# |
Nicholas Piggin3a166fc2017-06-20 01:52:05 +100018# +--< $(KBUILD_VMLINUX_LIBS)
19# | +--< lib/lib.a + more
20# |
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020021# +-< ${kallsymso} (see description in KALLSYMS section)
22#
23# vmlinux version (uname -v) cannot be updated during normal
24# descending-into-subdirs phase since we do not yet know if we need to
25# update vmlinux.
26# Therefore this step is delayed until just before final link of vmlinux.
27#
28# System.map is generated to document addresses of all kernel symbols
29
30# Error out on error
31set -e
32
33# Nice output in kbuild format
34# Will be supressed by "make -s"
35info()
36{
37 if [ "${quiet}" != "silent_" ]; then
Andrii Nakryikoe83b9f52019-04-02 09:49:50 -070038 printf " %-7s %s\n" "${1}" "${2}"
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020039 fi
40}
41
42# Link of vmlinux.o used for section mismatch analysis
43# ${1} output file
44modpost_link()
45{
Stephen Rothwella5967db2016-08-24 22:29:19 +100046 local objects
47
Nicholas Piggin6358d6e2018-02-11 00:25:03 +100048 objects="--whole-archive \
Masahiro Yamadad151e972019-01-17 09:10:04 +090049 ${KBUILD_VMLINUX_OBJS} \
Nicholas Piggin6358d6e2018-02-11 00:25:03 +100050 --no-whole-archive \
51 --start-group \
52 ${KBUILD_VMLINUX_LIBS} \
53 --end-group"
54
Masahiro Yamadad503ac52018-08-24 08:20:39 +090055 ${LD} ${KBUILD_LDFLAGS} -r -o ${1} ${objects}
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020056}
57
58# Link of vmlinux
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -070059# ${1} - output file
Andrii Nakryiko618916a2019-09-05 10:59:38 -070060# ${2}, ${3}, ... - optional extra .o files
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020061vmlinux_link()
62{
63 local lds="${objtree}/${KBUILD_LDS}"
Andrii Nakryiko618916a2019-09-05 10:59:38 -070064 local output=${1}
Stephen Rothwella5967db2016-08-24 22:29:19 +100065 local objects
Kees Cookaf73d782020-03-03 18:18:34 -080066 local strip_debug
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020067
Linus Torvaldsd7b08272019-09-20 08:36:47 -070068 info LD ${output}
69
Andrii Nakryiko618916a2019-09-05 10:59:38 -070070 # skip output file argument
71 shift
72
Kees Cookaf73d782020-03-03 18:18:34 -080073 # The kallsyms linking does not need debug symbols included.
74 if [ "$output" != "${output#.tmp_vmlinux.kallsyms}" ] ; then
75 strip_debug=-Wl,--strip-debug
76 fi
77
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020078 if [ "${SRCARCH}" != "um" ]; then
Nicholas Piggin6358d6e2018-02-11 00:25:03 +100079 objects="--whole-archive \
Masahiro Yamadad151e972019-01-17 09:10:04 +090080 ${KBUILD_VMLINUX_OBJS} \
Nicholas Piggin6358d6e2018-02-11 00:25:03 +100081 --no-whole-archive \
82 --start-group \
83 ${KBUILD_VMLINUX_LIBS} \
84 --end-group \
Andrii Nakryiko618916a2019-09-05 10:59:38 -070085 ${@}"
Stephen Rothwella5967db2016-08-24 22:29:19 +100086
Andrii Nakryiko618916a2019-09-05 10:59:38 -070087 ${LD} ${KBUILD_LDFLAGS} ${LDFLAGS_vmlinux} \
Kees Cookaf73d782020-03-03 18:18:34 -080088 ${strip_debug#-Wl,} \
Andrii Nakryiko618916a2019-09-05 10:59:38 -070089 -o ${output} \
Stephen Rothwella5967db2016-08-24 22:29:19 +100090 -T ${lds} ${objects}
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020091 else
Nicholas Piggin6358d6e2018-02-11 00:25:03 +100092 objects="-Wl,--whole-archive \
Masahiro Yamadad151e972019-01-17 09:10:04 +090093 ${KBUILD_VMLINUX_OBJS} \
Nicholas Piggin6358d6e2018-02-11 00:25:03 +100094 -Wl,--no-whole-archive \
95 -Wl,--start-group \
96 ${KBUILD_VMLINUX_LIBS} \
97 -Wl,--end-group \
Andrii Nakryiko618916a2019-09-05 10:59:38 -070098 ${@}"
Stephen Rothwella5967db2016-08-24 22:29:19 +100099
Andrii Nakryiko618916a2019-09-05 10:59:38 -0700100 ${CC} ${CFLAGS_vmlinux} \
Kees Cookaf73d782020-03-03 18:18:34 -0800101 ${strip_debug} \
Andrii Nakryiko618916a2019-09-05 10:59:38 -0700102 -o ${output} \
Nicholas Piggin6358d6e2018-02-11 00:25:03 +1000103 -Wl,-T,${lds} \
104 ${objects} \
Stephen Rothwella5967db2016-08-24 22:29:19 +1000105 -lutil -lrt -lpthread
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200106 rm -f linux
107 fi
108}
109
Andrii Nakryikoe83b9f52019-04-02 09:49:50 -0700110# generate .BTF typeinfo from DWARF debuginfo
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -0700111# ${1} - vmlinux image
112# ${2} - file to dump raw BTF data into
Andrii Nakryikoe83b9f52019-04-02 09:49:50 -0700113gen_btf()
114{
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -0700115 local pahole_ver
Andrii Nakryikoe83b9f52019-04-02 09:49:50 -0700116
Andrii Nakryiko581b31c2019-05-05 17:10:33 -0700117 if ! [ -x "$(command -v ${PAHOLE})" ]; then
Chris Down2a67a6c2020-01-22 00:01:10 +0000118 echo >&2 "BTF: ${1}: pahole (${PAHOLE}) is not available"
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -0700119 return 1
Andrii Nakryiko581b31c2019-05-05 17:10:33 -0700120 fi
121
Andrii Nakryikoe83b9f52019-04-02 09:49:50 -0700122 pahole_ver=$(${PAHOLE} --version | sed -E 's/v([0-9]+)\.([0-9]+)/\1\2/')
123 if [ "${pahole_ver}" -lt "113" ]; then
Chris Down2a67a6c2020-01-22 00:01:10 +0000124 echo >&2 "BTF: ${1}: pahole version $(${PAHOLE} --version) is too old, need at least v1.13"
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -0700125 return 1
Andrii Nakryikoe83b9f52019-04-02 09:49:50 -0700126 fi
127
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -0700128 vmlinux_link ${1}
Kees Cookaf73d782020-03-03 18:18:34 -0800129
130 info "BTF" ${2}
Andrii Nakryikoe83b9f52019-04-02 09:49:50 -0700131 LLVM_OBJCOPY=${OBJCOPY} ${PAHOLE} -J ${1}
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -0700132
Fangrui Song90ceddc2020-03-18 15:27:46 -0700133 # Create ${2} which contains just .BTF section but no symbols. Add
134 # SHF_ALLOC because .BTF will be part of the vmlinux image. --strip-all
135 # deletes all symbols including __start_BTF and __stop_BTF, which will
136 # be redefined in the linker script. Add 2>/dev/null to suppress GNU
137 # objcopy warnings: "empty loadable segment detected at ..."
138 ${OBJCOPY} --only-section=.BTF --set-section-flags .BTF=alloc,readonly \
139 --strip-all ${1} ${2} 2>/dev/null
140 # Change e_type to ET_REL so that it can be used to link final vmlinux.
141 # Unlike GNU ld, lld does not allow an ET_EXEC input.
142 printf '\1' | dd of=${2} conv=notrunc bs=1 seek=16 status=none
Andrii Nakryikoe83b9f52019-04-02 09:49:50 -0700143}
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200144
145# Create ${2} .o file with all symbols from the ${1} object file
146kallsyms()
147{
148 info KSYM ${2}
149 local kallsymopt;
150
151 if [ -n "${CONFIG_KALLSYMS_ALL}" ]; then
James Hogan6895f972012-09-06 22:11:25 +0100152 kallsymopt="${kallsymopt} --all-symbols"
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200153 fi
154
Ard Biesheuvel4d5d5662016-03-15 14:58:12 -0700155 if [ -n "${CONFIG_KALLSYMS_ABSOLUTE_PERCPU}" ]; then
Rusty Russellc6bda7c2014-03-17 14:05:46 +1030156 kallsymopt="${kallsymopt} --absolute-percpu"
157 fi
158
Ard Biesheuvel2213e9a2016-03-15 14:58:19 -0700159 if [ -n "${CONFIG_KALLSYMS_BASE_RELATIVE}" ]; then
160 kallsymopt="${kallsymopt} --base-relative"
161 fi
162
Sam Ravnborg00e6c28c2012-05-08 19:53:46 +0200163 local aflags="${KBUILD_AFLAGS} ${KBUILD_AFLAGS_KERNEL} \
164 ${NOSTDINC_FLAGS} ${LINUXINCLUDE} ${KBUILD_CPPFLAGS}"
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200165
Ard Biesheuvela0439342016-02-05 11:25:05 +0100166 local afile="`basename ${2} .o`.S"
167
168 ${NM} -n ${1} | scripts/kallsyms ${kallsymopt} > ${afile}
169 ${CC} ${aflags} -c -o ${2} ${afile}
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200170}
171
Kees Cook8959e392019-08-13 08:15:32 -0700172# Perform one step in kallsyms generation, including temporary linking of
173# vmlinux.
174kallsyms_step()
175{
176 kallsymso_prev=${kallsymso}
Kees Cookaf73d782020-03-03 18:18:34 -0800177 kallsyms_vmlinux=.tmp_vmlinux.kallsyms${1}
178 kallsymso=${kallsyms_vmlinux}.o
Kees Cook8959e392019-08-13 08:15:32 -0700179
Linus Torvaldsd7b08272019-09-20 08:36:47 -0700180 vmlinux_link ${kallsyms_vmlinux} "${kallsymso_prev}" ${btf_vmlinux_bin_o}
Kees Cook8959e392019-08-13 08:15:32 -0700181 kallsyms ${kallsyms_vmlinux} ${kallsymso}
182}
183
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200184# Create map file with all symbols from ${1}
185# See mksymap for additional details
186mksysmap()
187{
188 ${CONFIG_SHELL} "${srctree}/scripts/mksysmap" ${1} ${2}
189}
190
Shile Zhang10916702019-12-04 08:46:31 +0800191sorttable()
Linus Torvalds1347a2ce2012-05-28 10:32:28 -0700192{
Shile Zhang10916702019-12-04 08:46:31 +0800193 ${objtree}/scripts/sorttable ${1}
Linus Torvalds1347a2ce2012-05-28 10:32:28 -0700194}
195
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200196# Delete output files in case of error
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200197cleanup()
198{
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -0700199 rm -f .btf.*
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200200 rm -f .tmp_System.map
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200201 rm -f .tmp_vmlinux*
202 rm -f System.map
203 rm -f vmlinux
204 rm -f vmlinux.o
205}
206
Sylvain BERTRANDab160db2015-05-07 00:36:04 +0000207on_exit()
208{
209 if [ $? -ne 0 ]; then
210 cleanup
211 fi
212}
213trap on_exit EXIT
214
215on_signals()
216{
217 exit 1
218}
219trap on_signals HUP INT QUIT TERM
220
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200221#
222#
223# Use "make V=1" to debug this script
224case "${KBUILD_VERBOSE}" in
225*1*)
226 set -x
227 ;;
228esac
229
230if [ "$1" = "clean" ]; then
231 cleanup
232 exit 0
233fi
234
235# We need access to CONFIG_ symbols
Masahiro Yamada94cf8ac2019-03-08 14:49:10 +0900236. include/config/auto.conf
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200237
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200238# Update version
239info GEN .version
Masahiro Yamada278ae602017-09-22 14:31:13 +0900240if [ -r .version ]; then
241 VERSION=$(expr 0$(cat .version) + 1)
242 echo $VERSION > .version
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200243else
Masahiro Yamada278ae602017-09-22 14:31:13 +0900244 rm -f .version
245 echo 1 > .version
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200246fi;
247
248# final build of init/
Masahiro Yamada083bc0e2020-02-11 05:06:34 +0900249${MAKE} -f "${srctree}/scripts/Makefile.build" obj=init need-builtin=1
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200250
Nicholas Pigginabac4c82016-11-24 03:41:43 +1100251#link vmlinux.o
252info LD vmlinux.o
253modpost_link vmlinux.o
254
255# modpost vmlinux.o to check for section mismatches
Masahiro Yamadaa7215882019-07-31 00:59:02 +0900256${MAKE} -f "${srctree}/scripts/Makefile.modpost" MODPOST_VMLINUX=1
Nicholas Pigginabac4c82016-11-24 03:41:43 +1100257
Alexey Gladkov898490c2019-04-29 18:11:14 +0200258info MODINFO modules.builtin.modinfo
259${OBJCOPY} -j .modinfo -O binary vmlinux.o modules.builtin.modinfo
Masahiro Yamada8b41fc42019-12-19 17:33:29 +0900260info GEN modules.builtin
261# The second line aids cases where multiple modules share the same object.
262tr '\0' '\n' < modules.builtin.modinfo | sed -n 's/^[[:alnum:]:_]*\.file=//p' |
263 tr ' ' '\n' | uniq | sed -e 's:^:kernel/:' -e 's/$/.ko/' > modules.builtin
Alexey Gladkov898490c2019-04-29 18:11:14 +0200264
Andrii Nakryiko7fd78562019-08-13 11:54:42 -0700265btf_vmlinux_bin_o=""
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -0700266if [ -n "${CONFIG_DEBUG_INFO_BTF}" ]; then
Kees Cookaf73d782020-03-03 18:18:34 -0800267 btf_vmlinux_bin_o=.btf.vmlinux.bin.o
268 if ! gen_btf .tmp_vmlinux.btf $btf_vmlinux_bin_o ; then
Stanislav Fomichevda5fb182019-11-27 08:14:10 -0800269 echo >&2 "Failed to generate BTF for vmlinux"
270 echo >&2 "Try to disable CONFIG_DEBUG_INFO_BTF"
271 exit 1
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -0700272 fi
273fi
274
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200275kallsymso=""
Kees Cook8959e392019-08-13 08:15:32 -0700276kallsymso_prev=""
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200277kallsyms_vmlinux=""
278if [ -n "${CONFIG_KALLSYMS}" ]; then
279
280 # kallsyms support
281 # Generate section listing all symbols and add it into vmlinux
282 # It's a three step process:
283 # 1) Link .tmp_vmlinux1 so it has all symbols and sections,
284 # but __kallsyms is empty.
285 # Running kallsyms on that gives us .tmp_kallsyms1.o with
286 # the right size
287 # 2) Link .tmp_vmlinux2 so it now has a __kallsyms section of
288 # the right size, but due to the added section, some
289 # addresses have shifted.
290 # From here, we generate a correct .tmp_kallsyms2.o
Nicholas Piggin7e2b37c2016-11-24 03:41:37 +1100291 # 3) That link may have expanded the kernel image enough that
292 # more linker branch stubs / trampolines had to be added, which
293 # introduces new names, which further expands kallsyms. Do another
294 # pass if that is the case. In theory it's possible this results
295 # in even more stubs, but unlikely.
296 # KALLSYMS_EXTRA_PASS=1 may also used to debug or work around
297 # other bugs.
298 # 4) The correct ${kallsymso} is linked into the final vmlinux.
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200299 #
300 # a) Verify that the System.map from vmlinux matches the map from
301 # ${kallsymso}.
302
Kees Cook8959e392019-08-13 08:15:32 -0700303 kallsyms_step 1
304 kallsyms_step 2
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200305
Nicholas Piggin7e2b37c2016-11-24 03:41:37 +1100306 # step 3
Kees Cook8959e392019-08-13 08:15:32 -0700307 size1=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso_prev})
308 size2=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso})
Nicholas Piggin7e2b37c2016-11-24 03:41:37 +1100309
310 if [ $size1 -ne $size2 ] || [ -n "${KALLSYMS_EXTRA_PASS}" ]; then
Kees Cook8959e392019-08-13 08:15:32 -0700311 kallsyms_step 3
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200312 fi
313fi
314
Linus Torvaldsd7b08272019-09-20 08:36:47 -0700315vmlinux_link vmlinux "${kallsymso}" ${btf_vmlinux_bin_o}
Andrii Nakryikoe83b9f52019-04-02 09:49:50 -0700316
Shile Zhang10916702019-12-04 08:46:31 +0800317if [ -n "${CONFIG_BUILDTIME_TABLE_SORT}" ]; then
318 info SORTTAB vmlinux
Shile Zhangf14bf6a2019-12-04 08:46:33 +0800319 if ! sorttable vmlinux; then
320 echo >&2 Failed to sort kernel tables
321 exit 1
322 fi
Linus Torvalds1347a2ce2012-05-28 10:32:28 -0700323fi
324
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200325info SYSMAP System.map
326mksysmap vmlinux System.map
327
328# step a (see comment above)
329if [ -n "${CONFIG_KALLSYMS}" ]; then
330 mksysmap ${kallsyms_vmlinux} .tmp_System.map
331
332 if ! cmp -s System.map .tmp_System.map; then
Michal Marek5369f552012-07-07 23:04:40 +0200333 echo >&2 Inconsistent kallsyms data
Michal Marek367e43c2012-08-10 11:55:11 +0200334 echo >&2 Try "make KALLSYMS_EXTRA_PASS=1" as a workaround
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200335 exit 1
336 fi
337fi